PROGRAM Ultra_Enigma;
{De-/EnCoding program, based on the Germans Enigma machine, used in WW2}
USES Crt;
CONST BufSize = 65500;
TYPE ByteBuffer = ARRAY[0..BufSize] of Byte;
CONST defKey : ARRAY[0..255] of Byte =
(109,29,46,12,140,197,228,98,162,160,195,222,134,43,151,181,241,234,83,220,145,
139,247,26,171,255,237,10,170,48,55,21,33,201,90,233,169,167,158,138,30,168,190,
144,235,200,22,39,204,207,182,96,84,178,67,129,116,51,136,11,126,128,28,86,166,
211,225,42,117,108,249,45,62,210,230,172,0,123,14,50,179,196,133,157,180,203,
82,156,1,35,49,58,191,176,175,79,18,110,183,24,165,231,250,125,16,232,118,20,
53,226,224,205,101,219,31,66,229,159,112,23,122,239,68,216,246,184,194,77,193,
217,99,199,148,19,186,227,188,104,70,119,56,65,8,71,121,124,243,4,37,174,150,
209,253,127,89,13,76,60,208,85,152,57,34,106,105,213,147,3,164,40,131,6,189,154,
64,146,130,73,218,44,113,242,47,244,15,17,32,54,173,103,69,135,61,248,72,25,95,
75,2,202,93,107,142,143,132,102,80,27,63,114,192,120,198,141,185,87,88,149,97,
100,238,251,81,115,212,9,254,94,155,245,74,240,52,215,91,36,252,137,206,59,214,
111,5,38,92,161,223,187,177,41,78,7,153,236,221,163);

VAR key,revkey : ARRAY[0..255] of Byte;
 BFil:File of Byte;
 Fil:File;
 Buf:^ByteBuffer;
 s,Filename,filename2:String;
 Password:String[8];
 PassShift:ARRAY[0..8] of Byte;
 c : Char;
 b : byte;
 i,j,ii : Integer;
 l:LongInt;
 w:Word;

{ ROL(Byte,Digits) }
{Rotates the bits in a byte to the left. The bits that disappear out of}
{the byte, reappear in the other end. 0 >=Digits< 8 }
FUNCTION Rol(b,d:Byte):Byte;
BEGIN
 d:=d MOD 8;
 asm
	{MOV ax,0
	}
   MOV al,[b]
	{MOV cx,0
	}
   MOV cl,[d]
	ROL al,cl
	{OR al,ah}
	MOV [b],al
 END;
 Rol:=b;
END;

{ ROR(Byte,Digits) }
{Rotates the bits in a byte to the right. The bits that disappear out of}
{the byte, reappear in the other end. 0 <= Digits =>8 }
FUNCTION Ror(b,d:Byte):Byte;
BEGIN
 d:=d MOD 8;
 asm
	{MOV ax,0}
	MOV ah,[b]
	{MOV cx,0}
   MOV cl,[d]
	ROR ah,cl
	{OR ah,al}
	MOV [b],ah
 END;
 Ror:=b;
END;

FUNCTION Bait(I:Integer):Byte;
BEGIN
	{ REPEAT
		IF i>255 THEN i:=i-256;
		IF i<0 THEN i:=256-i;
	UNTIL (i>-1) AND (i<256);
	Bait:=i;
   }
   asm
    mov ax,[i]
    mov ah,0
    mov byte ptr [bait],al
   end;
END;

FUNCTION Treated(b:Byte):byte;
VAR bb : Byte;
i,j:Integer;
BEGIN
	FOR i:=1 TO 8 DO
	BEGIN
		b:=b+Ord(Password[i]);
		b := Key[b];  {Bait(b)}
	END;

	{bb:=b;}

	b:=255-b;

	i:=8;
	REPEAT
	{ FOR j:=0 TO 255 DO
		 IF (Key[j]=b) THEN BEGIN b:=Bait(j); b:=b-Ord(Password[i]); j:=255; dec(i); END;
   }
   b:=RevKey[b]-Ord(Password[i]);
   Dec(i);
	UNTIL i=0;

	Treated :=b;
END;

PROCEDURE GetPassword;
BEGIN
	Writeln;
	FOR i:=1 TO 8 DO BEGIN Password[i]:=chr(0); PassShift[i]:=0; END;
	Writeln('Enter password (8 digits max):');
	Readln(s);
	Password:=s;
   GotoXY(1,WhereY-1); ClrEol; Writeln;
END;

PROCEDURE RotatePassword;
BEGIN
	i:=8;
	REPEAT
		Inc(PassShift[i]);
		Password[i]:=Chr(Rol(Ord(Password[i]),1));

		IF PassShift[i]>=8 THEN BEGIN Dec(i); PassSHift[i]:=0; END ELSE i:=0;
	UNTIL i<1;

END;

PROCEDURE MakeTreated;
VAR Fil2:File{of Byte};
BEGIN
	GetPassword;
	IF password='' THEN Halt;

	FOR i:=0 TO 255 DO Key[i]:=DefKey[i]; {Key numbers for normal input}

   FOR j:=0 TO 255 DO    {Key numbers for reversed input}
     RevKey[Key[j]]:=j;

   {IF (Key[j]=b) THEN
     BEGIN b:=Bait(j); b:=b-Ord(Password[i]); j:=255; dec(i); END;
    }

	{
	filename:=ParamStr(1);
	IF filename='' THEN
	BEGIN
		Writeln('Enter name of key file:');
		Readln(filename);
	END;
	 filename:='U_ENIGMA.KEY';
	Assign(BFil,filename);
	Reset(BFil);
	FOR i:=0 TO 255 DO Read(BFil,key[i]);
	Close(BFil);
	}

	filename:=ParamStr(1);
	IF filename='' THEN
	BEGIN
		Writeln('Enter name of input file:');
		Readln(filename);
	END;

	filename2:=ParamStr(2);
	IF filename2='' THEN
	BEGIN
		Writeln('Enter name of output file:');
		Readln(filename2);
	END;

	Assign(Fil,Filename);
	Reset(Fil,1);
	Assign(Fil2,Filename2);
	Rewrite(Fil2,1);
	ii:=Lo(WindMax)-4;
	REPEAT
      BlockRead(Fil,Buf^,BufSize+1,w);
      FOR l:=0 TO w DO
      BEGIN
       Buf^[l]:=Treated(Buf^[l]);
       RotatePassword;

       IF (l and 15)=0 THEN   {15 = %1111 , 31 is faster}
       BEGIN
        i:=Trunc(ii*( FilePos(Fil)-w+l )/(FileSize(Fil)));
		  FOR j:=1 TO ii DO IF j>i THEN Write('.') ELSE Write('#');
		  Write(chr(13));
       END;

      END;
      BlockWrite(FIL2,Buf^,w);


	UNTIL Eof(Fil);


	Close(Fil); Close(Fil2);

END;

PROCEDURE HelpScreen;
BEGIN
   Writeln;
   Writeln('Commandline syntax: ENIGMA [Name of Inputfile] [Name of Outputfile]');

   {
	Assign(BFil,'U_ENIGMA.HLP');
	Reset(BFil);
	i:=15;
	REPEAT
		c:=#00;
		Read(BFil,b);
		Write(chr(b));
		IF b=10 THEN Dec(i);
		IF i<1 THEN BEGIN C:=ReadKey; i:=20; END;
	UNTIL (Eof(BFil)) or (C=#27);
	Close(BFil);
	c:=ReadKey;
   }
END;



BEGIN
   GetMem(Buf,BufSize);
	ClrScr;
	Writeln(chr(10));
	Writeln('   The Ultimate ENIGMA Machine');
	Writeln('   ---------- v0.97 ----------');
	Writeln('        Coded by Kent Dahl',chr(10));

	s:=ParamStr(1);
	FOR i:=1 TO Length(s) DO s[i]:=UpCase(s[i]);

	IF (s='H') OR (s='?') THEN HelpScreen ELSE MakeTreated;
   FreeMem(Buf,BufSize);

END.